<?php
require_once ("include/config.inc.php");

if (CFG_INTERACTION_TRACKBACK != 'yes') {
   error_404();
}

// POST ID ////////////////////////////////////////////////////////////////////
//
   $post_id = '';
   if (isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO'] != '/')
      $post_id = substr($_SERVER['PATH_INFO'],1,strlen($_SERVER['PATH_INFO'])-1);
//
///////////////////////////////////////////////////////////////////////////////

//
// - POST method: 
//    receive and store a trackback ping
//
// - GET  method: 
//    - mode 'rss'       : get  rss list of trackback pings for selected post
//    - mode 'list'      : get html list of trackback pings for selected post
//

// check POST|GET method
if (strtoupper($_SERVER['REQUEST_METHOD'] == 'POST')) {
   // check $post_id
   if ($post_id == '' || !post_exists($post_id)) {
      trackback_response('ko','you are trying to ping an invalid trackback url');
   }   
   
   // check requested parameters (url)
   if (!isset($_POST['url']) || $_POST['url'] == '') {
      trackback_response('ko','you must provide a valid url parameter');
   }
   
   // store trackback ping in the db
   $trackback = array();
   $trackback['trackback_title']     = $_POST['title'];
   $trackback['trackback_excerpt']   = $_POST['excerpt'];
   $trackback['trackback_url']       = $_POST['url'];
   $trackback['trackback_blog_name'] = $_POST['blog_name'];
   
   $trackback_id = trackback_ping_add($trackback);
   
   // send response
   if (!$trackback_id) {   // ko
      trackback_response('ko','server error: your ping could not be registered. please try again');
   }
   else {   // ok
      trackback_response('ok');
   }   
}
else {
   $mode = '';
   if (isset($_GET['__mode']))   $mode = $_GET['__mode'];
   
   if ($post_id == '') {
      error_404();
   }
   
   switch ($mode) {
      
      case 'rss':    // RSS list
         $post = post_details($post_id);
         $trackback_pings = trackback_pings_list($post_id);
         Header ('Content-type: text/xml');
         $tpl = new XTemplate ("templates/trackback.tpl.rss");
         $tpl->assign('POST', $post);
         if ($trackback_pings) {
            for ($c = 0; $c < count($trackback_pings); $c++) {
               $tpl->assign('TRACKBACK_PING', $trackback_pings[$c]);
               $tpl->parse('main.trackback_ping');
            }
         }
         $tpl->parse('main');
         $tpl->out('main');
         break;
      
      
      case 'list':   // HTML list
         $post = post_details($post_id);
         $trackback_pings = trackback_pings_list($post_id);
         $tpl = new XTemplate ("templates/trackback.tpl.htm");
         $tpl->assign('POST', $post);
         
         $tpl->assign('CFG_BODY_BGCOLOR', CFG_BODY_BGCOLOR);
         $tpl->assign('CFG_BACKGROUND_COLOR', CFG_BACKGROUND_COLOR);
         
         if ($trackback_pings) {
            for ($c = 0; $c < count($trackback_pings); $c++) {
               $tpl->assign('TRACKBACK_PING', $trackback_pings[$c]);
               $tpl->parse('main.trackback_ping');
            }
         }
         else {
            $tpl->parse('main.no_trackback_pings');
         }  
         $tpl->parse('main');
         $tpl->out('main');
         break;
                  
      
      default:       // ERROR
         error_404 ();
         break;
   }
}
?>
