<?php

// ####################################################################
// ____________________
// Su Logu - A PHP Blog
// --------------------
//
// (C) 2002, 2003 Fabio Pani
// http://www.fabiopani.it/blog/sulogu.html
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
// ####################################################################

require_once("language/language.php");

$diffminutes = 0;				// time difference (minutes) between local time and server time

// Check if a language exists.
function languageexists($language) {
	global $lang;

	$langfound = FALSE;
	foreach ($lang as $k => $l) {
		if (!$langfound)   { $langfound = ($l == $language); }
	}
	return $langfound;
}

// Return a MySQL-equivalent TIMESTAMP(12).
function gettimestamp12() {
	global $diffminutes;

	$tstamp = date("ymdHis");
	return date("ymdHis", mktime(substr($tstamp, 6, 2), substr($tstamp, 8, 2) + $diffminutes, substr($tstamp, 10, 2), substr($tstamp, 2, 2), substr($tstamp, 4, 2), "20" . substr($tstamp, 0, 2)));
	//return date("ymdHis");
}

// Convert a string in the range "01"-"12" into the corresponding full-lenght month's name.
// Note: $months is declared in the corresponding translation file <lang>.php. Backend utilities
// don't include the translation file.
function monthname($m) {
	global $months;

	if ($months[$m - 1]) {
		return $months[$m - 1];
	} else {
		return date("F", mktime(0, 0, 0, $m, 1, 2000));		// day and year are optional here
	}
}

// Return formatted date (and time, if $short is FALSE).
function fmtdatetime($tstamp, $short) {
	$res = htmlentities(substr(unhtmlentities(monthname(substr($tstamp, 2, 2))), 0, 3), ENT_NOQUOTES);	// only first three characters for month's name
	$res .= " " . substr($tstamp, 4, 2) . ", 20" . substr($tstamp, 0, 2);
	if (!$short)   { $res .= " @ " . substr($tstamp, 6, 2) . ":" . substr($tstamp, 8, 2); }
	return $res;
}

// Return the link to a smiley image.
function smileylink($s) {
	return "<IMG SRC=\"images/smileys/" . $s . ".png\" BORDER=\"0\">";
}

// Convert a smiley into an image.
// Please, don't modify the order of the following statements.
function showsmileys($s) {
	$res = ereg_replace(":-?\(\(", smileylink("17"), $s);   // recognize :(( or :-((
	$res = ereg_replace(":-?))", smileylink("18"), $res);   // :)) or :-))
	$res = ereg_replace(":-?)", smileylink("01"), $res);    // :) or :-)
	$res = ereg_replace(":-?\|", smileylink("19"), $res);   // :| or :-|
	$res = ereg_replace(":-?\(", smileylink("02"), $res);   // :( or :-(
	$res = ereg_replace(";-?)", smileylink("03"), $res);    // ;) or ;-)
	$res = ereg_replace(":-?D", smileylink("04"), $res);    // :D or :-D
	$res = ereg_replace(":-?p", smileylink("09"), $res);    // :p or :-p
	$res = ereg_replace("B-?)", smileylink("14"), $res);    // B) or B-)
	$res = ereg_replace("x-?\(", smileylink("12"), $res);   // x( or x-(
	return $res;
}

// Return the URL path of the document on the web.
function baseurl() {
	return "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
}

// Validate an URL. Rules:
// scheme must be 'http';
// host must contain at least one dot.
function validurl($u) {
	$url = @parse_url($u);
	return (($url['scheme'] == "http") && (ereg(".", $url['host'])));
}

// Convert a timestamp in an RFC 822 formatted date.
function rfcdate($tstamp) {
	return date("r", mktime(substr($tstamp, 6, 2), substr($tstamp, 8, 2), substr($tstamp, 10, 2), substr($tstamp, 2, 2), substr($tstamp, 4, 2), "20" . substr($tstamp, 0, 2)));
}

// Reverse of htmlentities() function. Example found in PHP manual.
function unhtmlentities($string) {
	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);
	return strtr($string, $trans_tbl);
}

// Get an RSS file (already connected to the database).
function getrss($format) {
	global $rssnum, $version, $blogname, $blogdesc, $bloglang, $blogcopyright, $rssttl, $blogeditormail, $webmastermail;
	switch ($format) {
		case "xml":
			$builddate = date("r");
			$generator = "Su Logu (version " . $version . ")";
			$burl = baseurl();
			$rssfile = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>\n";
			$rssfile .= "<!-- RSS generated by " . $generator . " on " . $builddate . " -->\n";
			$rssfile .= "<rss version=\"2.0\">\n";
			$rssfile .= "\t<channel>\n";
			$rssfile .= "\t\t<title>" . $blogname . "</title>\n";				// required
			$rssfile .= "\t\t<link>" . $burl . "</link>\n";						// required
			$rssfile .= "\t\t<description>" . $blogdesc . "</description>\n";	// required
			if ($bloglang)   { $rssfile .= "\t\t<language>" . $bloglang . "</language>\n"; }
			if ($blogcopyright)   { $rssfile .= "\t\t<copyright>" . $blogcopyright . "</copyright>\n"; }
			$rssfile .= "\t\t<lastBuildDate>" . $builddate . "</lastBuildDate>\n";
			$rssfile .= "\t\t<generator>" . $generator . "</generator>\n";
			if ($rssttl)   { $rssfile .= "\t\t<ttl>" . $rssttl . "</ttl>\n"; }
			if ($blogeditormail)   { $rssfile .= "\t\t<managingEditor>" . $blogeditormail . "</managingEditor>\n"; }
			if ($webmastermail)   { $rssfile .= "\t\t<webMaster>" . $webmastermail . "</webMaster>\n"; }
			$sql = "SELECT timeid, title FROM blog ";
			$sql .= "WHERE timeid <= '" . gettimestamp12() . "' ";
			$sql .= "ORDER BY timeid DESC LIMIT " . $rssnum;
			$res = mysql_query($sql);
			while ($line = mysql_fetch_array($res)) {
				$rssfile .= "\t\t<item>\n";
				$rssfile .= "\t\t\t<title>" . unhtmlentities($line['title']) . "</title>\n";
				$rssfile .= "\t\t\t<pubDate>" . rfcdate($line['timeid']) . "</pubDate>\n";
				$rssfile .= "\t\t\t<link>" . $burl . "?timeid=" . $line['timeid'] . "</link>\n";
				$rssfile .= "\t\t</item>\n";
			}
			$rssfile .= "\t</channel>\n";
			$rssfile .= "</rss>\n";
			break;
		default:
			$rssfile = "<HTML><HEAD></HEAD><BODY></BODY></HTML>\n";
	}
	return $rssfile;
}

if (eregi("utils.php", $PHP_SELF)) {
	header("Location: ../index.php");
	die();
}
?>
